package com.agfa.wildfly.interceptor.mdb;

import static org.hamcrest.CoreMatchers.is;
import static org.junit.Assert.assertThat;

import javax.annotation.Resource;
import javax.inject.Inject;
import javax.jms.JMSContext;
import javax.jms.Queue;

import org.jboss.arquillian.container.test.api.Deployment;
import org.jboss.arquillian.junit.Arquillian;
import org.jboss.shrinkwrap.api.ShrinkWrap;
import org.jboss.shrinkwrap.api.spec.JavaArchive;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;

@RunWith(Arquillian.class)
public class SendLogMessageIT {
    @Deployment
    public static JavaArchive createDeployment() {
        JavaArchive jar = ShrinkWrap.create(JavaArchive.class)
                .addPackages(true, "com.agfa.wildfly.interceptor.mdb")
                .addAsResource("META-INF/beans.xml", "META-INF/beans.xml")
                .addAsResource("META-INF/services/javax.enterprise.inject.spi.Extension", "META-INF/services/javax.enterprise.inject.spi.Extension");

//        jar.as(ZipExporter.class).exportTo(new File(String.format("%s.jar", SendLogMessageIT.class.getSimpleName())), true);

        return jar;
    }
    
    
    @Inject InterceptorCounter counter;
    
    @Inject JMSContext context;
    
    @Resource(lookup = "java:/queue/Logger/messages")
    private Queue queue;
    
    @Before
    public void setup() {
        counter.reset();
    }
    
    @Test
    public void whenSendingAMessageInterceptionOccuredAsExpected() {
        context.createProducer().send(queue, "cdi rocks when it works...");
        
        try {
            Thread.sleep(3000);
        } catch (InterruptedException e) {}

        // LoggerMessageListener.onMessage & ToUpperCaseStringTransformer.transform must have been intercepted
        assertThat(counter.value(), is(2));     
    }
}
